tpl 1.12 module CloudResource_LogicalSystemComponent;

metadata
    origin := "CIS";
    tree_path := "CIS", "cmdb", "CloudResource_LogicalSystemComponent";
    revision := "1.8";
    description := "Maps CloudResource to BMC_LogicalSystemComponent";
    // Main body from a pattern by a BMC consultant and posted into
    // BMC case 01114395.
end metadata;

from CMDB.CloudService_CloudInstance import CloudService_CloudInstance 1.1;

syncmapping CloudResource_LogicalSystemComponent 1.8
    "Maps CloudResource to BMC_LogicalSystemComponent"

    overview
        tags CMDB;
    end overview;

    mapping from CloudService_CloudInstance.cloud_svc as cloud_svc
        traverse Host:HostedSoftware:RunningSoftware:CloudResource as res
            res_ci -> BMC_LogicalSystemComponent;
        end traverse;
    end mapping;

    body
        cloud_svc_ci := CloudService_CloudInstance.cloud_svc_ci;

        for each res do
            res_ci := sync.BMC_RemoteFileSystem(
                key               := res.key,
                TokenId           := "ADDM:%res.key%",
                Name              := res.name,
                ShortDescription  := res.short_name or res.name,
                Description       := res.name,
                isCloud           := true,
                Model             := res.type,
                LogicalSystemType := res.type,
                Company           := cloud_svc_ci.Company,
                Category          := "Cloud",
                Type              := "Cloud Service",
                Item              := "Cloud Resource"
            );

            //sync.rel.BMC_Dependency(
            sync.rel.BMC_HostedSystemComponents(
                Source          := cloud_svc_ci,
                Destination     := res_ci,
                Impacted        := res_ci
                // Rel name seems to be an obsolete mapping attr, since
                // CMDB is generating rel names even for OOTB Cloud patterns.
            );
        end for;
    end body;

end syncmapping;
